unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    er: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    ed: TEdit;
    eu: TEdit;
    ea: TEdit;
    br: TButton;
    bd: TButton;
    bu: TButton;
    ba: TButton;
    Panel1: TPanel;
    Button1: TButton;
    Procedure Berechnungen(r: real);
    procedure brClick(Sender: TObject);
    procedure erKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure bdClick(Sender: TObject);
    procedure buClick(Sender: TObject);
    procedure baClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type TKreis = class(Tobject)
     private
         F_r: real;

     public
     function Getd:real;
     procedure Setd(d:real);
     function Getu:real;
     procedure Setu(u:real);
     function GetA:real;
     procedure SetA(a:real);

     property r: real read F_r write F_r;
     property d: real read Getd write Setd;
     property u: real read Getu write Setu;
     property A: real read GetA write SetA;
end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Function Tkreis.getd;
begin result := 2*r end;  //oder result := 2*F_r;

Procedure Tkreis.setd(d:real);
begin F_r := d/2 end;

Function Tkreis.getu;
begin result := Pi*d end;

Procedure Tkreis.setu(u:real);
begin F_r := u/(2*Pi) end;

Function Tkreis.getA;
begin result := Pi*r*r end;

Procedure Tkreis.setA(a:real);
begin F_r := sqrt(a/Pi) end;

Procedure Tform1.Berechnungen(r: real);
  var kreis: TKreis;
begin
  kreis := TKreis.Create;
  try
    kreis.r := r;
    er.text := FloatToStr(kreis.r);
    ed.text := FloatToStr(kreis.d);
    eu.text := FloatToStr(kreis.u);
    ea.text := FloatToStr(kreis.a);
  finally kreis.Free End;
end;

function mitPi(s:string): string;
  var x: real;
      k: integer;
begin
  for k := 1 to 100 do Begin
    x := k*(strToFloat(s)/Pi + 1E-8);
     if frac(x) < 1E-5 then BEgin
       if k=1 then
       result := floatToStr(round(x))+'*Pi' else
         result := floatToStr(round(x))+'/'+IntToStr(k)+'*Pi';
       exit;
     End;
  End;
  result := s;
end;

procedure TForm1.brClick(Sender: TObject);
  var r:real;
begin
  r := StrToFloat(er.text);
  berechnungen(r);
end;

procedure TForm1.erKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if sender <> er then er.text := '';
  if sender <> ed then ed.text := '';
  if sender <> eu then eu.text := '';
  if sender <> ea then ea.text := '';
end;

procedure TForm1.bdClick(Sender: TObject);
  var r:real;
begin
  r := StrToFloat(ed.text)/2;
  berechnungen(r);
end;


procedure TForm1.buClick(Sender: TObject);
  var r:real;
begin
  r := StrToFloat(eu.text)/(2*Pi);
  berechnungen(r);
end;


procedure TForm1.baClick(Sender: TObject);
  var r:real;
begin
  r := sqrt(StrToFloat(ea.text)/Pi);
  berechnungen(r);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  brClick(nil);
  eu.Text := mitPi(eu.text);
  eA.text := mitPi(eA.text);

end;

end.
